/*
 *    GRAVITY FORCE, gfmes.h
 *
 *
 *
 *    see source.txt for further information
 */

// Gravity Force
// messages

#define  middle(A,B)  ((A/2)-(B/2))

// general messages
typedef struct {
  char text1[50];
  char text2[50];
  char text3[150];
} MESSAGE_TYPE;

enum error_messages
{
  MSG_ERROR_GRAPHIC_INIT,
  MSG_ERROR_SOUND_INIT,
  MSG_ERROR_SOUND_INIT2,
  MSG_ERROR_FILE_NOT_FOUND,
  MSG_ERROR_GFXFILE,
  MSG_ERROR_MAPFILE,
  MSG_ERROR_CFGFILE,
  MSG_ERROR_LNGFILE,
  MSG_ERROR_ERROR
};

MESSAGE_TYPE error_message[11];

enum cargo_messages
{
  MSG_CARGO_FUEL,
  MSG_CARGO_LIFE,
  MSG_CARGO_MAN,
  MSG_CARGO_SHIELD1,
  MSG_CARGO_SHIELD2,
  MSG_CARGO_BOMBS,
  MSG_CARGO_BULLETS,
  MSG_CARGO_BIGBOMBS,
  MSG_CARGO_MISSILES,
  MSG_CARGO_CARGO1,
  MSG_CARGO_CARGO2,
  MSG_CARGO_RECEIVED,
  MSG_CARGO_LEFT,
  MSG_CARGO_MINES1,
  MSG_CARGO_MINES2,
  MSG_CARGO_MINES3,
  MSG_CARGO_SLOT6NA
};

MESSAGE_TYPE cargo_message[20];


enum mission_messages
{
  MSG_MISSION_GAMEOVER,
  MSG_MISSION_COMPLETE,
  MSG_MISSION_FAILED,
  MSG_MISSION_RACE_COMPLETE
};

MESSAGE_TYPE mission_message[5];


enum other_messages
{
  MSG_OTHER_NOFUEL,
  MSG_OTHER_BOMBINGRUN,
  MSG_OTHER_REMTIME,
  MSG_OTHER_TIME,
  MSG_OTHER_LAP,
  MSG_OTHER_MEGA_AUTOFIRE,
  MSG_OTHER_MEGA_SHIELD,
  MSG_OTHER_MINUTES,
  MSG_OTHER_SECONDS
};

MESSAGE_TYPE other_message[10];


enum menu_messages
{
  MSG_MENU_YES,
  MSG_MENU_NO,
  MSG_MENU_SINGLEPLAYER,
  MSG_MENU_MULTIPLAYER,
  MSG_MENU_RACE,
  MSG_MENU_TRAINING,
  MSG_MENU_DOGFIGHT,
  MSG_MENU_MPRACE,
  MSG_MENU_QDOGFIGHT,
  MSG_MENU_CAMPAIGN,
  MSG_MENU_OPTIONS,
  MSG_MENU_PLAYDEMO,
  MSG_MENU_QUIT,
  MSG_MENU_LEVEL,
  MSG_MENU_PLAY,
  MSG_MENU_PLAYLEVEL,
  MSG_MENU_UNLOCKLEVEL,
  MSG_MENU_PASSWORD,
  MSG_MENU_BACK,
  MSG_MENU_RECDEMO,
  MSG_MENU_SCORE,
  MSG_MENU_NAME,
  MSG_MENU_FILENAME,
  MSG_MENU_VERSION,
  MSG_MENU_OPT_PIXANZ,
  MSG_MENU_OPT_PIXANZ_DESC,
  MSG_MENU_OPT_RESOLUTION,
  MSG_MENU_OPT_SOUNDVOL,
  MSG_MENU_OPT_SOUNDVOL_DESC,
  MSG_MENU_OPT_LANGUAGE,
  MSG_MENU_OPT_LANGUAGE_DESC,
  MSG_MENU_OPT_GERMAN,
  MSG_MENU_OPT_ENGLISH,
  MSG_MENU_OPT_SLOVAK,
  MSG_MENU_PLAYER,
  MSG_MENU_OK,
  MSG_MENU_SELECT,
  MSG_MENU_ENTER_PASSWORD,
  MSG_MENU_OPT_ZOOM,
  MSG_MENU_OPT_ZOOM_DESC,
  MSG_MENU_OPT_PGRAV,
  MSG_MENU_OPT_PGRAV_DESC,
  MSG_MENU_OPT_ON,
  MSG_MENU_OPT_OFF,
  MSG_MENU_OPT_DEBRIS,
  MSG_MENU_OPT_DEBRIS_DESC,
  MSG_MENU_OPT_MMUSIC,
  MSG_MENU_OPT_MMUSIC_DESC,
  MSG_MENU_OPT_HATEIT,
  MSG_MENU_FRAG_LIMIT,
  MSG_MENU_TIME_LIMIT,
  MSG_MENU_GRAVITY,
  MSG_MENU_P1WEAPONS,
  MSG_MENU_P2WEAPONS,
  MSG_MENU_EXTRAS,
  MSG_MENU_NONE,
  MSG_MENU_RARE,
  MSG_MENU_MEDIUM,
  MSG_MENU_MUCH,

  MSG_KEY_CONTROLS,
  MSG_KEY_2PLAYER,
  MSG_KEY_THRUST,
  MSG_KEY_SHOOT,
  MSG_KEY_LEFT,
  MSG_KEY_RIGHT,
  MSG_KEY_SPECIAL,
  MSG_KEY_NWEAPON,
  MSG_KEY_PWEAPON,
  MSG_KEY_W1,
  MSG_KEY_W2,
  MSG_KEY_W3,
  MSG_KEY_W4,
  MSG_KEY_W5,
  MSG_KEY_W6,

  MSG_KEY_ESC,
  MSG_KEY_F1,
  MSG_KEY_F2,
  MSG_KEY_F3,
  MSG_KEY_F4,
  MSG_KEY_F5,
  MSG_KEY_F6,
  MSG_KEY_F7,
  MSG_KEY_F8,
  MSG_KEY_F9,
  MSG_KEY_F10,
  MSG_KEY_F11,
  MSG_KEY_F12,

  MSG_KEY_TILDE,
  MSG_KEY_MINUS,
  MSG_KEY_EQUALS,
  MSG_KEY_BACKSPACE,
  MSG_KEY_TAB,
  MSG_KEY_OPENBRACE,
  MSG_KEY_CLOSEBRACE,
  MSG_KEY_ENTER,
  MSG_KEY_COLON,
  MSG_KEY_QUOTE,
  MSG_KEY_BACKSLASH,
  MSG_KEY_BACKSLASH2,
  MSG_KEY_COMMA,
  MSG_KEY_STOP,
  MSG_KEY_SLASH,
  MSG_KEY_SPACE,

  MSG_KEY_INSERT,
  MSG_KEY_DELETE,
  MSG_KEY_HOME,
  MSG_KEY_END,
  MSG_KEY_PGUP,
  MSG_KEY_PGDOWN,
  MSG_KEY_ARLEFT,
  MSG_KEY_ARRIGHT,
  MSG_KEY_ARUP,
  MSG_KEY_ARDOWN,
  MSG_KEY_SLASH_PAD,
  MSG_KEY_ASTERISK,
  MSG_KEY_MINUS_PAD,
  MSG_KEY_PLUS_PAD,
  MSG_KEY_DEL_PAD,
  MSG_KEY_ENTER_PAD,
                
  MSG_KEY_LSHIFT,
  MSG_KEY_RSHIFT,
  MSG_KEY_LCTRL,
  MSG_KEY_RCTRL,
  MSG_KEY_LALT,
  MSG_KEY_RALT,
  MSG_KEY_PAUSE,
  MSG_JOY0_UP,
  MSG_JOY0_DOWN,
  MSG_JOY0_LEFT,
  MSG_JOY0_RIGHT,
  MSG_JOY0_B1,
  MSG_JOY0_B2,
  MSG_JOY0_B3,
  MSG_JOY0_B4,
  MSG_JOY0_B5,
  MSG_JOY0_B6,
  MSG_JOY0_B7,
  MSG_JOY0_B8,
  MSG_JOY0_B9,
  MSG_JOY0_B10,
  MSG_JOY0_B11,
  MSG_JOY1_UP,
  MSG_JOY1_DOWN,
  MSG_JOY1_LEFT,
  MSG_JOY1_RIGHT,
  MSG_JOY1_B1,
  MSG_JOY1_B2,
  MSG_JOY1_B3,
  MSG_JOY1_B4
};

MESSAGE_TYPE menu_message[184];


enum stat_messages
{
  MSG_STAT_STATISTICS,
  MSG_STAT_STATUS,
  MSG_STAT_LIFES,
  MSG_STAT_FUEL,
  MSG_STAT_KILLED,
  MSG_STAT_KILLED_QUALITY,
  MSG_STAT_CARGOSAVED,
  MSG_STAT_HITPERCENT,
  MSG_STAT_TIMEUSED,
  MSG_STAT_SCORE,
  MSG_STAT_INHISCORE,
  MSG_STAT_HISCORECODE,
  MSG_STAT_ENTER_NAME,
  MSG_STAT_PRESS_KEY,
  MSG_STAT_LAP,
  MSG_STAT_TIME,
  MSG_STAT_OVERALL_TIME,
  MSG_STAT_FRAGS,
  MSG_STAT_SUICIDES,
  MSG_STAT_FRAGSMIN,
  MSG_STAT_EXTRASTAKEN,
  MSG_STAT_TIMEPLAYED,
  MSG_STAT_WINNER,
  MSG_STAT_PLAYER,
  MSG_STAT_DRAW,
  MSG_STAT_PLACE
};

MESSAGE_TYPE stat_message[27];


enum l_action_messages
{
  MSG_LEVEL_ACTION1,
  MSG_LEVEL_ACTION2,
  MSG_LEVEL_ACTION3,
  MSG_LEVEL_ACTION4,
  MSG_LEVEL_ACTION5,
  MSG_LEVEL_ACTION6,
  MSG_LEVEL_ACTION7,
  MSG_LEVEL_ACTION8,
  MSG_LEVEL_ACTION9,
  MSG_LEVEL_ACTION10
};

MESSAGE_TYPE l_action_message[10];


enum l_misc_messages
{
  MSG_LEVEL_MISC1,
  MSG_LEVEL_MISC2,
  MSG_LEVEL_MISC3,
  MSG_LEVEL_MISC4,
  MSG_LEVEL_MISC5
};

MESSAGE_TYPE l_misc_message[5];


// level specific messages
int cur_info_line;

typedef struct {
  int  mode;
  int  time;
  int  length;
  int  clear;
  int  border;
  int  ypos;
  int speed;
  int color1;
  int color2;
  int user1,user2;
  FONT *font1;
  FONT *font2;
  char text1[250];
  char text2[50];
} LEVEL_TEXT;

LEVEL_TEXT level_info[10];
int level_info_maxlines;
int abort_start_message;


// Header aus gfmes.c

void read_message_file(int language_setting);
void read_level_message_file(int language_setting);
void clear_level_info();
void read_level_text(int language_setting);
void show_level_info_message();
void jhtextout(BITMAP *bmp, FONT *f, unsigned char *s, int x, int y, int color);

